use fantoccini::{Client, ClientBuilder};
pub mod collector;
use collector::*;

#[tokio::main]
async fn main() {
    let start = std::time::Instant::now();
    println!("Spawning client");
    let c: Client = ClientBuilder::native()
        .connect("http://localhost:4444")
        .await
        .expect("failed to connect to WebDriver");
    println!("Getting links");
    let links = get_top_links(&c, 1)
        .await
        .expect("Failed to get links. Exiting");
    println!("Got {} links. Expected {}", links.len(), 5 * 15);
    println!("Getting answers");
    let mut answers = vec![];
    for (i, link) in links.iter().enumerate() {
        answers.append(
            &mut get_answers(&c, format!("https://stackoverflow.com{}", link).as_str(), i)
                .await
                .unwrap_or_default(),
        );
    }
    println!(
        "Got {} answers in {} sec",
        answers.len(),
        start.elapsed().as_secs_f32()
    );
    c.close().await.unwrap();
}
